#!/usr/local/bin/perl
#
#  \[Xt@Cenum#defineɕϊ܂
#  s̐擪Ƀ\[Xt@CƕϊO̍sԍRgƂđ}܂
#  Java/C++`̃RgɑΉĂ܂
#
#  g
#   1) perl enum2def.pl \[Xt@C
#   2) perl enum2def.pl < \[Xt@C
#
#  ϊꂽ\[Xt@C̓eWo͂ɏo͂܂
#

$sharp = "#";
$enum    = 0; # >0:enum
$comment = 0; #  1:Rg

while (<>)
{
	$filename = $ARGV;
	if ($filename =~ m!.+[\\/](.+?)$!) {
		$filename = $1;
	}

	# vvZbTߍs͏Ȃ
	if (/^\s*$sharp/) {
		print "$_";
		next;
	}

	# sԍt
	if (!$comment && $enum == 0) {
		printf "/* $filename(%d): */", $.;
	}

	# 
	&analyze($_);
}

sub analyze {
	my($line) = @_;

	if (!$comment) {
		##
		##  R[hǐՒ
		##
		if ($line =~ m!(^"|[^\\]"|//|/\*)!s) {
			if ($1 eq "//") {
				$line = "$1$'";
				&analyze($`);
				if ($enum == 0) {
					print $line;
				}
			} elsif ($1 eq "/*") {
				$line = $';
				&analyze($`);
				if ($enum == 0) {
					print "/*";
				}
				$comment = 1;
				&analyze($line);
			} else {
				my($str1, $str2);
				$line = $';
				$str1 = $`;
				$str2 = $1;
				$str2 =~ /(.*)"/;
				$str1 = "$str1$1";
				&analyze($str1);
				$line =~ /(.*[^\\]"|^")/s;
				print "\"$1";
				&analyze($');
			}
		} else {
			if ($enum == 0) {
				if ($line =~ /enum/) {
					&analyze($`);
					$count = 0;
					$value = "";
					$enum ++;
					&analyze($');
				} else {
					print $line;
				}
			} elsif ($enum == 1) {
				if ($line =~ /(\S)/) {
					if ($1 eq "{") {
						$enum ++;
						&analyze($');
					} else {
						$enum = 0;
						print $line;
					}
				}
			} elsif ($enum == 2) {
				if ($line =~ /(\S)/) {
					if ($1 eq "}") {
						$enum = 5;
						&analyze($line);
					} else {
						if ($line =~ /\w+/) {
							$field = $&;
							$enum ++;
							&analyze($');
						} else {
							$enum = 0;
							print $line;
						}
					}
				}
			} elsif ($enum == 3) {
				if ($line =~ /(\S)/) {
					if ($1 eq "," || $1 eq "}") {
						$enum = 5;
						&analyze($line);
					} elsif ($1 eq "=") {
						$count = 0;
						$enum ++;
						&analyze($');
					} else {
						$enum = 0;
						print $line;
					}
				}
			} elsif ($enum == 4) {
				if ($line =~ /(.*),/) {
					$line = ",$'";
					$value = "$1";
					$value =~ s/^\s+//;
					$value =~ s/\s+$//;
					$enum ++;
					&analyze($line);
				} elsif ($line =~ /(.*)$/) {
					$value = "$1";
					$value =~ s/^\s+//;
					$value =~ s/\s+$//;
					$enum ++;
					&analyze($');
				} else {
					print $line;
				}
			} elsif ($enum == 5) {
				if ($line =~ /(\S)/) {
					if ($1 eq "," || $1 eq "}") {
						if ($field ne "") {
							print "\n${sharp}define $field ";
							if ($value ne "") {
								printf "(($value) + %d)", $count;
							} else {
								printf "(%d)", $count;
							}
							$field = "";
							$count ++;
						}
						$enum ++;
						if ($1 eq ",") {
							$enum = 2;
						}
						&analyze($');
					}
				}
			} elsif ($enum == 6) {
				if ($line =~ /(\S)/) {
					if ($1 eq ";") {
						printf "\n";
						printf "/* $filename(%d): */", $.;
						$enum = 0;
						&analyze($');
					} else {
						$enum = 0;
						print $line;
					}
				}
			} else {
				print $line;
			}
		}
	} else {
		##
		##  Rgp
		##
		if ($line =~ m!\*/!s) {
			if ($enum == 0) {
				print "$`$&";
			}
			$comment = 0;
			&analyze($');
		} else {
			if ($enum == 0) {
				print $line;
			}
		}
	}
}
